unit Macros2;


interface

	uses
		QuickDraw, Palettes, PrintTraps, globals;

	procedure InitSymbolTable;


implementation


	procedure InitSymbolTable;
		var
			i: integer;
	begin
		with MacrosP^ do begin
				nSymbols := 241;
				for i := 1 to MaxSymbols do
					with SymbolTable[i] do begin
							tType := CommandT;
							cType := NullC;
							loc := 0;
						end;

				with SymbolTable[1] do begin
						symbol := 'begin       ';
						tType := BeginT;
					end;
				with SymbolTable[2] do begin
						symbol := 'convolve    ';
						cType := ConvolveC;
					end;
				with SymbolTable[3] do begin
						symbol := 'fill        ';
						cType := FillC;
					end;
				with SymbolTable[4] do begin
						symbol := 'selectall   ';
						cType := SelectC;
					end;
				with SymbolTable[5] do begin
						symbol := 'invert      ';
						cType := InvertC;
					end;
				with SymbolTable[6] do begin
						symbol := 'killroi     ';
						cType := KillC;
					end;
				with SymbolTable[7] do begin
						symbol := 'markselectio';
						cType := MarkC;
					end;
				with SymbolTable[8] do begin
						symbol := 'drawboundary';
						cType := FrameC;
					end;
				with SymbolTable[9] do begin
						symbol := 'measure     ';
						cType := MeasureC;
					end;
				with SymbolTable[10] do begin
						symbol := 'fliphorizont';
						cType := FliphC;
					end;
				with SymbolTable[11] do begin
						symbol := 'analyzeparti';
						cType := AnalyzeC;
					end;
				with SymbolTable[12] do begin
						symbol := 'nextwindow  ';
						cType := NextC;
					end;
				with SymbolTable[13] do begin
						symbol := 'paste       ';
						cType := PasteC;
					end;
				with SymbolTable[14] do begin
						symbol := 'clear       ';
						cType := ClearC;
					end;
				with SymbolTable[15] do begin
						symbol := 'copy        ';
						cType := CopyC;
					end;
				with SymbolTable[16] do begin
						symbol := 'restoreroi  ';
						cType := RestoreC;
					end;
				with SymbolTable[17] do begin
						symbol := 'setthreshold';
						cType := ThresholdC;
					end;
				with SymbolTable[18] do begin
						symbol := 'resetgraymap';
						cType := ResetgmC;
					end;
				with SymbolTable[19] do begin
						symbol := 'makebinary  ';
						cType := MakeBinC;
					end;
				with SymbolTable[20] do begin
						symbol := 'dither      ';
						cType := DitherC;
					end;
				with SymbolTable[21] do begin
						symbol := 'smooth      ';
						cType := SmoothC;
					end;
				with SymbolTable[22] do begin
						symbol := 'scalemath   ';
						cType := ScaleMathC;
					end;
				with SymbolTable[23] do begin
						symbol := 'sharpen     ';
						cType := SharpenC;
					end;
				with SymbolTable[24] do begin
						symbol := 'inverty     ';
						cType := InvertYC;
					end;
				with SymbolTable[25] do begin
						symbol := 'calibrated  ';
						tType := FunctionT;
						cType := CalibratedC;
					end;
				with SymbolTable[26] do begin
						symbol := 'divide      ';
						cType := DivC;
					end;
				with SymbolTable[27] do begin
						symbol := 'redirect    ';
						cType := RedirectC;
					end;
				with SymbolTable[28] do begin
						symbol := 'getresults  ';
						cType := GetResultsC;
					end;
				with SymbolTable[29] do begin
						symbol := 'wait        ';
						cType := WaitC;
					end;
				with SymbolTable[30] do begin
						symbol := 'resetcounter';
						cType := ResetmC;
					end;
				with SymbolTable[31] do begin
						symbol := 'setdensitysl';
						cType := SetSliceC;
					end;
				with SymbolTable[32] do begin
						symbol := 'undo        ';
						cType := UndoC;
					end;
				with SymbolTable[33] do begin
						symbol := 'setforegroun';
						cType := SetForeC;
					end;
				with SymbolTable[34] do begin
						symbol := 'setbackgroun';
						cType := SetBackC;
					end;
				with SymbolTable[35] do begin
						symbol := 'scaleandrota';
						cType := ScaleC;
					end;
				with SymbolTable[36] do begin
						symbol := 'rotateright ';
						cType := RotateRC;
					end;
				with SymbolTable[37] do begin
						symbol := 'rotateleft  ';
						cType := RotateLC;
					end;
				with SymbolTable[38] do begin
						symbol := 'traceedges  ';
						cType := TraceC;
					end;
				with SymbolTable[39] do begin
						symbol := 'multiply    ';
						cType := MulC;
					end;
				with SymbolTable[40] do begin
						symbol := 'showhistogra';
						cType := HistoC;
					end;
				with SymbolTable[41] do begin
						symbol := 'enhancecontr';
						cType := EnhanceC;
					end;
				with SymbolTable[42] do begin
						symbol := 'equalizehist';
						cType := EqualizeC;
					end;
				with SymbolTable[43] do begin
						symbol := 'erode       ';
						cType := ErodeC;
					end;
				with SymbolTable[44] do begin
						symbol := 'dilate      ';
						cType := DilateC;
					end;
				with SymbolTable[45] do begin
						symbol := 'outline     ';
						cType := OutlineC;
					end;
				with SymbolTable[46] do begin
						symbol := 'skeletonize ';
						cType := ThinC;
					end;
				with SymbolTable[47] do begin
						symbol := 'addconstant ';
						cType := AddConstC;
					end;
				with SymbolTable[48] do begin
						symbol := 'reverttosave';
						cType := RevertC;
					end;
				with SymbolTable[49] do begin
						symbol := 'shadow      ';
						cType := ShadowC;
					end;
				with SymbolTable[50] do begin
						symbol := 'flipvertical';
						cType := FlipvC;
					end;
				with SymbolTable[51] do begin
						symbol := 'end         ';
						tType := EndT;
					end;
				with SymbolTable[52] do begin
						symbol := 'getline     ';
						cType := GetLineC;
					end;
				with SymbolTable[53] do begin
						symbol := 'var         ';
						tType := VarT;
					end;
				with SymbolTable[54] do begin
						symbol := 'for         ';
						tType := ForT;
					end;
				with SymbolTable[55] do begin
						symbol := 'integer     ';
						tType := IntegerT;
					end;
				with SymbolTable[56] do begin
						symbol := 'to          ';
						tType := ToT;
					end;
				with SymbolTable[57] do begin
						symbol := 'do          ';
						tType := DoT;
					end;
				with SymbolTable[58] do begin
						symbol := 'beep        ';
						cType := BeepC;
					end;
				with SymbolTable[59] do begin
						symbol := 'capture     ';
						cType := CaptureC;
					end;
				with SymbolTable[60] do begin
						symbol := 'makeroi     ';
						cType := MakeC;
					end;
				with SymbolTable[61] do begin
						symbol := 'moveroi     ';
						cType := MoveC;
					end;
				with SymbolTable[62] do begin
						symbol := 'insetroi    ';
						cType := InsetC;
					end;
				with SymbolTable[63] do begin
						symbol := 'moveto      ';
						cType := MoveToC;
					end;
				with SymbolTable[64] do begin
						symbol := 'drawtext    ';
						cType := DrawTextC;
					end;
				with SymbolTable[65] do begin
						symbol := 'setfont     ';
						cType := SetFontC;
					end;
				with SymbolTable[66] do begin
						symbol := 'setfontsize ';
						cType := SetFontSizeC;
					end;
				with SymbolTable[67] do begin
						symbol := 'settext     ';
						cType := SetTextC;
					end;
				with SymbolTable[68] do begin
						symbol := 'drawnumber  ';
						cType := DrawNumC;
					end;
				with SymbolTable[69] do begin
						symbol := 'or          ';
						tType := orOp;
					end;
				with SymbolTable[70] do begin
						symbol := 'and         ';
						tType := andOp;
					end;
				with SymbolTable[71] do begin
						symbol := 'div         ';
						tType := IntDivOp;
					end;
				with SymbolTable[72] do begin
						symbol := 'mod         ';
						tType := modOp;
					end;
				with SymbolTable[73] do begin
						symbol := 'getpicsize  ';
						cType := GetPicSizeC;
					end;
				with SymbolTable[74] do begin
						symbol := 'putmessage  ';
						cType := PutMsgC;
					end;
				with SymbolTable[75] do begin
						symbol := 'exit        ';
						cType := ExitC;
					end;
				with SymbolTable[76] do begin
						symbol := 'if          ';
						tType := ifT;
					end;
				with SymbolTable[77] do begin
						symbol := 'then        ';
						tType := thenT;
					end;
				with SymbolTable[78] do begin
						symbol := 'else        ';
						tType := elseT;
					end;
				with SymbolTable[79] do begin
						symbol := 'while       ';
						tType := whileT;
					end;
				with SymbolTable[80] do begin
						symbol := 'repeat      ';
						tType := repeatT;
					end;
				with SymbolTable[81] do begin
						symbol := 'until       ';
						tType := untilT;
					end;
				with SymbolTable[82] do begin
						symbol := 'not         ';
						tType := NotOp;
					end;
				with SymbolTable[83] do begin
						symbol := 'getroi      ';
						cType := GetRoiC;
					end;
				with SymbolTable[84] do begin
						symbol := 'real        ';
						tType := RealT;
					end;
				with SymbolTable[85] do begin
						symbol := 'trunc       ';
						tType := FunctionT;
						cType := TruncC;
					end;
				with SymbolTable[86] do begin
						symbol := 'round       ';
						tType := FunctionT;
						cType := RoundC;
					end;
				with SymbolTable[87] do begin
						symbol := 'getnumber   ';
						tType := FunctionT;
						cType := GetNumC;
					end;
				with SymbolTable[88] do begin
						symbol := 'nop         ';
						cType := NopC;
					end;
				with SymbolTable[89] do begin
						symbol := 'random      ';
						tType := FunctionT;
						cType := RandomC;
					end;
				with SymbolTable[90] do begin
						symbol := 'makeovalroi ';
						cType := MakeOvalC;
					end;
				with SymbolTable[91] do begin
						symbol := 'drawscale   ';
						cType := DrawScaleC;
					end;
				with SymbolTable[92] do begin
						symbol := 'setpalette  ';
						cType := SetPaletteC;
					end;
				with SymbolTable[93] do begin
						symbol := 'makenewwindo';
						cType := MakeNewC;
					end;
				with SymbolTable[94] do begin
						symbol := 'getpixel    ';
						tType := FunctionT;
						cType := GetPixelC;
					end;
				with SymbolTable[95] do begin
						symbol := 'button      ';
						tType := FunctionT;
						cType := ButtonC;
					end;
				with SymbolTable[96] do begin
						symbol := 'odd         ';
						tType := FunctionT;
						cType := oddC;
					end;
				with SymbolTable[97] do begin
						symbol := 'abs         ';
						tType := FunctionT;
						cType := absC;
					end;
				with SymbolTable[98] do begin
						symbol := 'sqrt        ';
						tType := FunctionT;
						cType := sqrtC;
					end;
				with SymbolTable[99] do begin
						symbol := 'sin         ';
						tType := FunctionT;
						cType := sinC;
					end;
				with SymbolTable[100] do begin
						symbol := 'cos         ';
						tType := FunctionT;
						cType := cosC;
					end;
				with SymbolTable[101] do begin
						symbol := 'exp         ';
						tType := FunctionT;
						cType := expC;
					end;
				with SymbolTable[102] do begin
						symbol := 'ln          ';
						tType := FunctionT;
						cType := lnC;
					end;
				with SymbolTable[103] do begin
						symbol := 'arctan      ';
						tType := FunctionT;
						cType := arctanC;
					end;
				with SymbolTable[104] do begin
						symbol := 'sqr         ';
						tType := FunctionT;
						cType := sqrC;
					end;
				with SymbolTable[105] do begin
						symbol := 'macro       ';
						tType := MacroT;
					end;
				with SymbolTable[106] do begin
						symbol := 'procedure   ';
						tType := ProcIdT;
					end;
				with SymbolTable[107] do begin
						symbol := 'open        ';
						cType := openC;
					end;
				with SymbolTable[108] do begin
						symbol := 'setimport   ';
						cType := SetImportC;
					end;
				with SymbolTable[109] do begin
						symbol := 'import      ';
						cType := ImportC;
					end;
				with SymbolTable[110] do begin
						symbol := 'setimportmin';
						cType := SetMinMaxC;
					end;
				with SymbolTable[111] do begin
						symbol := 'setcustom   ';
						cType := SetCustomC;
					end;
				with SymbolTable[112] do begin
						symbol := 'npics       ';
						tType := FunctionT;
						cType := nPicsC;
					end;
				with SymbolTable[113] do begin
						symbol := 'selectpic   ';
						cType := SelectPicC;
					end;
				with SymbolTable[114] do begin
						symbol := 'setpicname  ';
						cType := SetPicNameC;
					end;
				with SymbolTable[115] do begin
						symbol := 'applylut    ';
						cType := ApplyLutC;
					end;
				with SymbolTable[116] do begin
						symbol := 'multiplybyco';
						cType := MulConstC;
					end;
				with SymbolTable[117] do begin
						symbol := 'setnewsize  ';
						cType := SetSizeC;
					end;
				with SymbolTable[118] do begin
						symbol := 'save        ';
						cType := SaveC;
					end;
				with SymbolTable[119] do begin
						symbol := 'saveall     ';
						cType := SaveAllC;
					end;
				with SymbolTable[120] do begin
						symbol := 'saveas      ';
						cType := SaveAsC;
					end;
				with SymbolTable[121] do begin
						symbol := 'copyresults ';
						cType := CopyResultsC;
					end;
				with SymbolTable[122] do begin
						symbol := 'boolean     ';
						tType := BooleanT;
					end;
				with SymbolTable[123] do begin
						symbol := 'true        ';
						tType := TrueT;
					end;
				with SymbolTable[124] do begin
						symbol := 'false       ';
						tType := FalseT;
					end;
				with SymbolTable[125] do begin
						symbol := 'close       ';
						cType := CloseC;
					end;
				with SymbolTable[126] do begin
						symbol := 'dispose     ';
						cType := DisposeC;
					end;
				with SymbolTable[127] do begin
						symbol := 'disposeall  ';
						cType := DisposeAllC;
					end;
				with SymbolTable[128] do begin
						symbol := 'duplicate   ';
						cType := DupC;
					end;
				with SymbolTable[129] do begin
						symbol := 'getinfo     ';
						cType := GetInfoC;
					end;
				with SymbolTable[130] do begin
						symbol := 'print       ';
						cType := PrintC;
					end;
				with SymbolTable[131] do begin
						symbol := 'lineto      ';
						cType := LineToC;
					end;
				with SymbolTable[132] do begin
						symbol := 'setplotlabel';
						cType := SetLabelsC;
					end;
				with SymbolTable[133] do begin
						symbol := 'setplotscale';
						cType := SetPlotScaleC;
					end;
				with SymbolTable[134] do begin
						symbol := 'setplotsize ';
						cType := SetDimC;
					end;
				with SymbolTable[135] do begin
						symbol := 'setscaling  ';
						cType := ScalingOptionsC;
					end;
				with SymbolTable[136] do begin
						symbol := 'columnaverag';
						cType := ColumnC;
					end;
				with SymbolTable[137] do begin
						symbol := 'setchannel  ';
						cType := ChannelC;
					end;
				with SymbolTable[138] do begin
						symbol := 'showpastecon';
						cType := ShowPasteC;
					end;
				with SymbolTable[139] do begin
						symbol := 'setoption   ';
						cType := SetOptionC;
					end;
				with SymbolTable[140] do begin
						symbol := 'doand       ';
						cType := AndC;
					end;
				with SymbolTable[141] do begin
						symbol := 'door        ';
						cType := OrC;
					end;
				with SymbolTable[142] do begin
						symbol := 'doxor       ';
						cType := XorC;
					end;
				with SymbolTable[143] do begin
						symbol := 'doblend     ';
						cType := BlendC;
					end;
				with SymbolTable[144] do begin
						symbol := 'doreplace   ';
						cType := ReplaceC;
					end;
				with SymbolTable[145] do begin
						symbol := 'add         ';
						cType := AddC;
					end;
				with SymbolTable[146] do begin
						symbol := 'subtract    ';
						cType := SubC;
					end;
				with SymbolTable[147] do begin
						symbol := 'setlinewidth';
						cType := SetWidthC;
					end;
				with SymbolTable[148] do begin
						symbol := 'showresults ';
						cType := ShowResultsC;
					end;
				with SymbolTable[149] do begin
						symbol := 'startcapturi';
						cType := StartC;
					end;
				with SymbolTable[150] do begin
						symbol := 'getrow      ';
						cType := GetRowC;
					end;
				with SymbolTable[151] do begin
						symbol := 'putrow      ';
						cType := PutRowC;
					end;
				with SymbolTable[152] do begin
						symbol := 'getcolumn   ';
						cType := GetColumnC;
					end;
				with SymbolTable[153] do begin
						symbol := 'putcolumn   ';
						cType := PutColumnC;
					end;
				with SymbolTable[154] do begin
						symbol := 'allsamesize ';
						tType := FunctionT;
						cType := SameSizeC;
					end;
				with SymbolTable[155] do begin
						symbol := 'cvalue      ';
						tType := FunctionT;
						cType := cValueC;
					end;
				with SymbolTable[156] do begin
						symbol := 'plotxyz     ';
						cType := PlotXYZC;
					end;
				with SymbolTable[157] do begin
						symbol := 'includeinter';
						cType := IncludeC;
					end;
				with SymbolTable[158] do begin
						symbol := 'wandautomeas';
						cType := AutoC;
					end;
				with SymbolTable[159] do begin
						symbol := 'labelparticl';
						cType := LabelC;
					end;
				with SymbolTable[160] do begin
						symbol := 'outlineparti';
						cType := OutlineParticlesC;
					end;
				with SymbolTable[161] do begin
						symbol := 'ignorepartic';
						cType := IgnoreC;
					end;
				with SymbolTable[162] do begin
						symbol := 'adjustareas ';
						cType := AdjustC;
					end;
				with SymbolTable[163] do begin
						symbol := 'setparticles';
						cType := SetParticleSizeC;
					end;
				with SymbolTable[164] do begin
						symbol := 'setprecision';
						cType := SetPrecisionC;
					end;
				with SymbolTable[165] do begin
						symbol := 'measurearea ';
						cType := AreaC;
					end;
				with SymbolTable[166] do begin
						symbol := 'measuredensi';
						cType := DensityC;
					end;
				with SymbolTable[167] do begin
						symbol := 'measurestand';
						cType := StdC;
					end;
				with SymbolTable[168] do begin
						symbol := 'measurexy   ';
						cType := XyC;
					end;
				with SymbolTable[169] do begin
						symbol := 'measuremode ';
						cType := ModeC;
					end;
				with SymbolTable[170] do begin
						symbol := 'measureperim';
						cType := PerimeterC;
					end;
				with SymbolTable[171] do begin
						symbol := 'measuremajor';
						cType := MajorC;
					end;
				with SymbolTable[172] do begin
						symbol := 'measureminor';
						cType := MinorC;
					end;
				with SymbolTable[173] do begin
						symbol := 'measureangle';
						cType := AngleC;
					end;
				with SymbolTable[174] do begin
						symbol := 'measureinteg';
						cType := IntDensityC;
					end;
				with SymbolTable[175] do begin
						symbol := 'putpixel    ';
						cType := PutPixelC;
					end;
				with SymbolTable[176] do begin
						symbol := 'choosepic   ';
						cType := ChoosePicC;
					end;
				with SymbolTable[177] do begin
						symbol := 'write       ';
						cType := WriteC;
					end;
				with SymbolTable[178] do begin
						symbol := 'writeln     ';
						cType := WritelnC;
					end;
				with SymbolTable[179] do begin
						symbol := 'scaleselecti';
						cType := ScaleSelectionC;
					end;
				with SymbolTable[180] do begin
						symbol := 'picnumber   ';
						tType := FunctionT;
						cType := PicNumC;
					end;
				with SymbolTable[181] do begin
						symbol := 'export      ';
						cType := ExportC;
					end;
				with SymbolTable[182] do begin
						symbol := 'reducenoise ';
						cType := ReduceC;
					end;
				with SymbolTable[183] do begin
						symbol := 'changevalues';
						cType := ChangeC;
					end;
				with SymbolTable[184] do begin
						symbol := 'histogram   ';
						tType := ArrayT;
						cType := HistogramC;
					end;
				with SymbolTable[185] do begin
						symbol := 'measureminma';
						cType := MinMaxC;
					end;
				with SymbolTable[186] do begin
						symbol := 'rarea       ';
						tType := ArrayT;
						cType := rAreaC;
					end;
				with SymbolTable[187] do begin
						symbol := 'rmean       ';
						tType := ArrayT;
						cType := rMeanC;
					end;
				with SymbolTable[188] do begin
						symbol := 'rx          ';
						tType := ArrayT;
						cType := rXC;
					end;
				with SymbolTable[189] do begin
						symbol := 'ry          ';
						tType := ArrayT;
						cType := rYC;
					end;
				with SymbolTable[190] do begin
						symbol := 'rmin        ';
						tType := ArrayT;
						cType := rMinC;
					end;
				with SymbolTable[191] do begin
						symbol := 'rmax        ';
						tType := ArrayT;
						cType := rMaxC;
					end;
				with SymbolTable[192] do begin
						symbol := 'rcount      ';
						tType := FunctionT;
						cType := rCountC;
					end;
				with SymbolTable[193] do begin
						symbol := 'updateresult';
						cType := UpdateResultsC;
					end;
				with SymbolTable[194] do begin
						symbol := 'stopcapturin';
						cType := StopC;
					end;
				with SymbolTable[195] do begin
						symbol := 'tilewindows ';
						cType := TileC;
					end;
				with SymbolTable[196] do begin
						symbol := 'rlength     ';
						tType := ArrayT;
						cType := rLengthC;
					end;
				with SymbolTable[197] do begin
						symbol := 'rmajor      ';
						tType := ArrayT;
						cType := rMajorC;
					end;
				with SymbolTable[198] do begin
						symbol := 'rminor      ';
						tType := ArrayT;
						cType := rMinorC;
					end;
				with SymbolTable[199] do begin
						symbol := 'rangle      ';
						tType := ArrayT;
						cType := rAngleC;
					end;
				with SymbolTable[200] do begin
						symbol := 'setmajorlabe';
						cType := SetMajorC;
					end;
				with SymbolTable[201] do begin
						symbol := 'setminorlabe';
						cType := SetMinorC;
					end;
				with SymbolTable[202] do begin
						symbol := 'getmouse    ';
						cType := GetMouseC;
					end;
				with SymbolTable[203] do begin
						symbol := 'slicenumber ';
						tType := FunctionT;
						cType := GetSliceC;
					end;
				with SymbolTable[204] do begin
						symbol := 'nslices     ';
						tType := FunctionT;
						cType := nSlicesC;
					end;
				with SymbolTable[205] do begin
						symbol := 'selectslice ';
						cType := SelectSliceC;
					end;
				with SymbolTable[206] do begin
						symbol := 'addslice    ';
						cType := AddSliceC;
					end;
				with SymbolTable[207] do begin
						symbol := 'deleteslice ';
						cType := DeleteSliceC;
					end;
				with SymbolTable[208] do begin
						symbol := 'makenewstack';
						cType := MakeStackC;
					end;
				with SymbolTable[209] do begin
						symbol := 'averageframe';
						cType := AverageFramesC;
					end;
				with SymbolTable[210] do begin
						symbol := 'waitfortrigg';
						cType := TriggerC;
					end;
				with SymbolTable[211] do begin
						symbol := 'docopy      ';
						cType := CopyModeC;
					end;
				with SymbolTable[212] do begin
						symbol := 'reslice     ';
						cType := ResliceC;
					end;
				with SymbolTable[213] do begin
						symbol := 'makelineroi ';
						cType := MakeLineC;
					end;
				with SymbolTable[214] do begin
						symbol := 'plotprofile ';
						cType := PlotProfileC;
					end;
				with SymbolTable[215] do begin
						symbol := 'gettime     ';
						cType := GetTimeC;
					end;
				with SymbolTable[216] do begin
						symbol := 'setscale    ';
						cType := SetScaleC;
					end;
				with SymbolTable[217] do begin
						symbol := 'savestate   ';
						cType := SaveStateC;
					end;
				with SymbolTable[218] do begin
						symbol := 'restorestate';
						cType := RestoreStateC;
					end;
				with SymbolTable[219] do begin
						symbol := 'setcounter  ';
						cType := SetCounterC;
					end;
				with SymbolTable[220] do begin
						symbol := 'redlut      ';
						tType := ArrayT;
						cType := RedLutC;
					end;
				with SymbolTable[221] do begin
						symbol := 'greenlut    ';
						tType := ArrayT;
						cType := GreenLutC;
					end;
				with SymbolTable[222] do begin
						symbol := 'bluelut     ';
						tType := ArrayT;
						cType := BlueLutC;
					end;
				with SymbolTable[223] do begin
						symbol := 'updatelut   ';
						cType := UpdateLutC;
					end;
				with SymbolTable[224] do begin
						symbol := 'showmessage ';
						cType := ShowMsgC;
					end;
				with SymbolTable[225] do begin
						symbol := 'setbinarycou';
						cType := SetCountC;
					end;
				with SymbolTable[226] do begin
						symbol := 'rstddev     ';
						tType := ArrayT;
						cType := rStdDevC;
					end;
				with SymbolTable[227] do begin
						symbol := 'propagatelut';
						cType := PropagateLutC;
					end;
				with SymbolTable[228] do begin
						symbol := 'chooseslice ';
						cType := ChooseSliceC;
					end;
				with SymbolTable[229] do begin
						symbol := 'setslicespac';
						cType := SetSpacingC;
					end;
				with SymbolTable[230] do begin
						symbol := 'getslicespac';
						tType := FunctionT;
						cType := GetSpacingC;
					end;
				with SymbolTable[231] do begin
						symbol := 'linebuffer  ';
						tType := ArrayT;
						cType := BufferC;
					end;
				with SymbolTable[232] do begin
						symbol := 'ruser1      ';
						tType := ArrayT;
						cType := rUser1C;
					end;
				with SymbolTable[233] do begin
						symbol := 'ruser2      ';
						tType := ArrayT;
						cType := rUser2C;
					end;
				with SymbolTable[234] do begin
						symbol := 'propagateden';
						cType := PropagateDensityC;
					end;
				with SymbolTable[235] do begin
						symbol := 'propagatespa';
						cType := PropagateSpatialC;
					end;
				with SymbolTable[236] do begin
						symbol := 'setoptions  ';
						cType := SetOptionsC;
					end;
				with SymbolTable[237] do begin
						symbol := 'requiresvers';
						cType := RequiresC;
					end;
				with SymbolTable[238] do begin
						symbol := 'getplotcount';
						tType := FunctionT;
						cType := GetPlotCountC;
					end;
				with SymbolTable[239] do begin
						symbol := 'plotdata    ';
						tType := ArrayT;
						cType := PlotDataC;
					end;
				with SymbolTable[240] do begin
						symbol := 'setuser1labe';
						cType := SetUser1C;
					end;
				with SymbolTable[241] do begin
						symbol := 'setuser2labe';
						cType := SetUser2C;
					end;
			end; {with}
	end;

end.