unit TalkInput;

{ This program was written by Peter N Lewis, Mar 1992 in THINK Pascal 4.0.1 }

interface

	procedure InitTalkInput;
	procedure FinishTalkInput;
	procedure Talk;

implementation

	uses
		MyAddressInput, MyUtilities, OOMainLoop, AppGlobals, Preferences, {}
		TCPTypes, TCPStuff, TCPConnections, TalkUtils, Talks, MyDialogs, TalkTos;

	type
		TIObject = object(AIObject)
				procedure PackStringBlank (var s: str255);
				override;
				procedure PackString (var s: str255);
				override;
				procedure UnPackString (s: str255);
				override;
				function IsOKOn: boolean;
				override;
				function IsSetDefaultOn: boolean;
				override;
				procedure DoCommand (s: str255);
				override;
			end;

	procedure TIObject.PackStringBlank (var s: str255);
	begin
		if (default_machine = '') and (default_user = '') then
			s := '@'
		else
			PackName(s, default_user, default_machine);
	end;

	procedure TIObject.PackString (var s: str255);
	begin
		PackName(s, default_user, default_machine);
	end;

	procedure TIObject.UnPackString (s: str255);
	begin
		UnPackName(s, default_user, default_machine);
	end;

	function TIObject.IsOKOn: boolean;
		var
			s, s1, s2: str255;
			nsetdefon: boolean;
	begin
		GetItemText(window, ai_user, s1);
		GetItemText(window, ai_machine, s2);
		PackName(s, s1, s2);
		IsOKOn := s <> '?';
	end;

	function TIObject.IsSetDefaultOn: boolean;
		var
			s, s1, s2: str255;
			nsetdefon: boolean;
	begin
		GetItemText(window, ai_user, s1);
		GetItemText(window, ai_machine, s2);
		PackName(s, s1, s2);
		IsSetDefaultOn := (s <> '?') or ((s1 = '') and (s2 = ''));
	end;

	procedure TIObject.DoCommand (s: str255);
	begin
		TalkTo(s);
	end;

{$ Init}
	procedure InitTalkInput;
	begin
		InitAddressInput;
	end;

{$ Term}
	procedure FinishTalkInput;
	begin
	end;

{$S}
	procedure Talk;
		var
			fio: TIObject;
	begin
		new(fio);
		fio.Create(talk_input_dialog_id);
		ShowWindow(fio.window);
	end;

end.